/*
 * Projecte Fressa a JAVA
 * File    : TFormColorMarc.java
 * Created : 1 / maig / 2009, 19:06
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 * amb el suport del Departament d'Educacio de la Generalitat de Catalunya
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class TFormColorMarc extends javax.swing.JDialog {
    
  public javax.swing.JButton jButtonDAcord;
  public javax.swing.JButton jButtonCancelar;

  public int resultat = 0;
  
  ColorChooserDemo newContentPane;
  
  public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
      public void run() {
        new TFormColorMarc(new javax.swing.JFrame(), true).setVisible(true);
      }
    });
  }
    
  public TFormColorMarc(java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
  }
    
  public TFormColorMarc(javax.swing.JDialog parent, boolean modal) {
    super(parent, modal);
    initComponents();
  }

  private void initComponents() {
    newContentPane = new ColorChooserDemo();
    newContentPane.setOpaque(true); //content panes must be opaque
    setContentPane(newContentPane);
    setSize(440,400);
    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Color quadre seguiment del mouse");
    setResizable(false);
    
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        Toolkit.getDefaultToolkit().removeAWTEventListener(ListenerReturnEsc);
        Global.ColorFranja=newContentPane.tcc.getColor();    
      }
    });
    
  }
  
  private AWTEventListener ListenerReturnEsc = new AWTEventListener() {
    public void eventDispatched(AWTEvent event) {
      KeyEvent ke = (KeyEvent)event;
      if (ke.getID() == KeyEvent.KEY_TYPED) {
        if (ke.getKeyChar() == KeyEvent.VK_ESCAPE) {
          jButtonCancelarClick();
        } else if (ke.getKeyChar() == KeyEvent.VK_ENTER) {
          if (jButtonCancelar.isFocusOwner()) {
            jButtonCancelarClick()  ;
          } else {
            jButtonDAcordClick();
          }             
        }
      }
    }
  };

  private void jButtonDAcordClick() {                                         
    Toolkit.getDefaultToolkit().removeAWTEventListener(ListenerReturnEsc);
    resultat=1;
    setVisible(false);
    Global.ColorFranja=newContentPane.tcc.getColor();    
  }                                        

  private void jButtonCancelarClick() {                                         
    Toolkit.getDefaultToolkit().removeAWTEventListener(ListenerReturnEsc);
    resultat=0;
    setVisible(false);   
    //Global.ColorFranja=newContentPane.tcc.getColor();    
  }                                        

  public void ShowModalCentered() {
    newContentPane.tcc.setColor(Global.ColorFranja);
    Toolkit.getDefaultToolkit().addAWTEventListener(ListenerReturnEsc,AWTEvent.KEY_EVENT_MASK);
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = this.getSize();
    if (frameSize.height > screenSize.height) frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width) frameSize.width = screenSize.width;
    this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    this.setVisible(true);      
  }
  
}
