/*
 * Projecte Fressa a JAVA
 * File    : TFormMouse.java
 * Created : 10 / abril / 2009, 19:50
 *
 * @author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 * amb el suport del Departament d'Educacio de la Generalitat de Catalunya
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class TFormMouse extends JFrame implements ActionListener {
  
  private Frame pare;
  public javax.swing.JPanel panelMouse;
  TFormScreen Screen;
  public boolean MenuItemClicAutomatic=false;
  public JPanel panell;
  public Cursor NormalCursor;
  public Cursor CustomCursor;
  public Timer TimerClicMestard;
  public int TimerClicMestardPosicio=0;

  public TFormMouse(Frame parent,int x, int y, int dx, int dy) { 
    setUndecorated(true);
    setResizable(false);
    if (Global.FormMouseQuadreGran) {
      panell = new JPanel();
      panell.setBackground(Color.red);
      getContentPane().add(panell);
    }  
    pare=parent;
    //panelMouse = new JPanel();
    //panelMouse.addMouseListener(new java.awt.event.MouseAdapter()  {
    this.addMouseListener(new java.awt.event.MouseAdapter()  {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        MouseEvent Me = (MouseEvent)evt;
        if (Me.getButton() == MouseEvent.BUTTON3) {
          AnarAlNouPunt();
        } if (Me.getButton() == MouseEvent.BUTTON1) {
          FerClick();          
        }
      }
    });
    this.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(java.awt.event.KeyEvent evt) {
        KeyEvent Ke = (KeyEvent)evt;
        int NumeroTecla=-1;
        if (Ke.getKeyCode()==KeyEvent.VK_TAB) {
          AnarAlNouPunt();
        } if (Ke.getKeyCode()==KeyEvent.VK_RIGHT) {
          AnarAlNouPunt();
        } if (Ke.getKeyCode()==KeyEvent.VK_ENTER) {
          FerClick();          
        } if ((Ke.getKeyChar()>=48) && (Ke.getKeyChar()<=57)) {
          NumeroTecla=Ke.getKeyChar()-48;                          
        } else if ((Ke.getKeyChar()>=65) && (Ke.getKeyChar()<=90)) {
          NumeroTecla=Ke.getKeyChar()-65+10;                
        } else if ((Ke.getKeyChar()>=97) && (Ke.getKeyChar()<=122)) {
          NumeroTecla=Ke.getKeyChar()-97+10;                
        }
        if (NumeroTecla>-1) {
          NumeroTecla++; 
          if (NumeroTecla<=Screen.NumeroDePunts) {
            Screen.Lloc=NumeroTecla;
            AnarAlNouPunt();
            if (MenuItemClicAutomatic) {
              Screen.JavaKanghooru.TimerClicMestard.start();
              //FerClick();                        
            }
          }
        }
      }
    });

    setLocation(x,y);
    setSize(dx,dy);
    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setAlwaysOnTop(true);

    //BEGIN 37
    NormalCursor=getCursor();
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    Image cursorImage = toolkit.getImage("cursor.gif");
    Point cursorHotSpot = new Point(0,0);
    CustomCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "Cursor");
    //setCursor(CustomCursor);
    //setCursor(NormalCursor);
    //END 37
    //TimerClicMestard  = new Timer(100,this);
  }
    
  public void CanviMides (int x, int y, int dx, int dy) {
    setLocation(x,y);
    setSize(dx,dy);    
  }

  public void CanviPosicio (int x, int y) {
    setLocation(x,y);    
  }

  public void AnarAlNouPunt() {
    //setVisible(true);
    try {
      Screen.MoureRata(Screen.px[Screen.Lloc],Screen.py[Screen.Lloc]);
    } catch (AWTException ae) {
       System.out.println(ae);
    }
    if (Global.FormMouseQuadreGran) {
      CanviPosicio(Screen.px[Screen.Lloc]-10,Screen.py[Screen.Lloc]-10);
    } else {  
      CanviPosicio(Screen.px[Screen.Lloc],Screen.py[Screen.Lloc]);
    }  
    this.setVisible(true);
    this.requestFocus();
    Screen.Lloc=Screen.Lloc+1;
    int LlocAnterior;
    if (Screen.Lloc>Screen.NumeroDePunts) {
      Screen.Lloc=1;
      LlocAnterior=Screen.NumeroDePunts;
    } else {
      LlocAnterior=Screen.Lloc-1;  
    }    
  }
  
  public void FerClick() {
    Screen.JavaKanghooru.TimerPosicioMouse.stop();
    setVisible(false);
    TimerClicMestardPosicio=1;
    /*
    if (Global.FormMouseScaneigDirigitCal2Clics) {
      TimerClicMestard.start();
    } else {
      try {
        Robot r = new Robot();
        r.mousePress(InputEvent.BUTTON1_MASK);
        r.mouseRelease(InputEvent.BUTTON1_MASK);
      } catch (AWTException e) {
        e.printStackTrace();
      }
    }
     */
     /**/
    try {
      Robot r = new Robot();
      r.mousePress(InputEvent.BUTTON1_MASK);
      r.mouseRelease(InputEvent.BUTTON1_MASK);
      if (Global.FormMouseScaneigDirigitCal2Clics) {
        r.mousePress(InputEvent.BUTTON1_MASK);
        r.mouseRelease(InputEvent.BUTTON1_MASK);
      }  
    } catch (AWTException e) {
      e.printStackTrace();
    }
     /**/
    if (Screen.ActivarQuadreSegiment) {
      Screen.Franja1.setVisible(true);
      Screen.Franja2.setVisible(true);
      Screen.Franja3.setVisible(true);
      Screen.Franja4.setVisible(true);       
    }
    pare.setVisible(true);
    this.setVisible(true);
    this.requestFocus();
    Screen.JavaKanghooru.TimerPosicioMouse.start();
  }
  
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == TimerClicMestard){
      if (TimerClicMestardPosicio==1) {
        TimerClicMestardPosicio=2;
        try {
          Robot r = new Robot();
          r.mousePress(InputEvent.BUTTON1_MASK);
          r.mouseRelease(InputEvent.BUTTON1_MASK);
        } catch (AWTException er) {
          er.printStackTrace();
        }
      } else if (TimerClicMestardPosicio==2) {
        TimerClicMestardPosicio=3;
        try {
          Robot r = new Robot();
          r.mousePress(InputEvent.BUTTON1_MASK);
          r.mouseRelease(InputEvent.BUTTON1_MASK);
        } catch (AWTException er) {
          er.printStackTrace();
        }
      } else if (TimerClicMestardPosicio==3) {
        TimerClicMestardPosicio=0;
        TimerClicMestard.stop();
        if (Screen.ActivarQuadreSegiment) {
          Screen.Franja1.setVisible(true);
          Screen.Franja2.setVisible(true);
          Screen.Franja3.setVisible(true);
          Screen.Franja4.setVisible(true);       
        }
        pare.setVisible(true);
        this.setVisible(true);
        this.requestFocus();
        Screen.JavaKanghooru.TimerPosicioMouse.start();
      }  
    }
  }

}  
