/*
 * Projecte Fressa a JAVA
 * TFormScreen.java
 * Created on 13/juny/2007, 07:23
 *
 * @author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 * amb el suport del Departament d'Educacio de la Generalitat de Catalunya
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 */

import javax.swing.*;
import java.awt.*;
import javax.swing.event.MouseInputListener;
import java.awt.event.MouseEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Robot;

public class TFormScreen extends JFrame implements MouseInputListener,ActionListener {
    
   
  private Frame pare;
  public javax.swing.JLabel panell;
  public int NumeroMaximDePunts = 1000;
  public int Lloc;
  public int NumeroDePunts;
  public int px[] = new int[NumeroMaximDePunts]; 
  public int py[] = new int[NumeroMaximDePunts]; 
  public Timer TimerEscaneig;
  public int TimerEscaneigInterval=1200;
  private int PosicioX;
  private int PosicioY;
  public boolean EnScaneigFerSonarUnBeep = false;
  TFormFranja Franja1, Franja2, Franja3, Franja4;
  public boolean ActivarQuadreSegiment=false;
  public boolean WindowsVistaComensoEscaneig=true;
  public static JavaKanghooru JavaKanghooru;

  public TFormScreen(Frame parent) { 
    NumeroDePunts=-1;
    setUndecorated(true);
    setResizable(false);
    panell = new JLabel();
    getContentPane().add(panell);
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setLocation(0,0);
    setSize(screenSize.width,screenSize.height);
    addMouseListener(this);
    addMouseMotionListener(this);
    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    pare=parent;
    //TimerEscaneig = new Timer(2000,this);
    //TimerEscaneig = new Timer(TimerEscaneigInterval,this);
    /*
    int x=100;
    int y=100;
    int dx=100;
    int dy=100;
     */
    int x=Global.FranjaX;
    int y=Global.FranjaY;
    int dx=Global.FranjaDX;
    int dy=Global.FranjaDY;
    Franja1 = new TFormFranja(this,x,y,Global.FranjaAmplada,dy);
    Franja2 = new TFormFranja(this,x,y,dx,Global.FranjaAmplada);
    Franja3 = new TFormFranja(this,x+dx-Global.FranjaAmplada,y,Global.FranjaAmplada,dy);
    Franja4 = new TFormFranja(this,dx,y+dy-Global.FranjaAmplada,dx,Global.FranjaAmplada);
  }
    
  public void CanviMidesQuadrat(int x, int y, int dx, int dy) {
    Franja1.setVisible(false);
    Franja2.setVisible(false);
    Franja3.setVisible(false);
    Franja4.setVisible(false);
    Franja1.CanviMides(x,y,Global.FranjaAmplada,dy);
    Franja2.CanviMides(x,y,dx,Global.FranjaAmplada);
    Franja3.CanviMides(x+dx-Global.FranjaAmplada,y,Global.FranjaAmplada,dy);
    Franja4.CanviMides(x,y+dy-Global.FranjaAmplada,dx,Global.FranjaAmplada);
    Franja1.setVisible(true);
    Franja2.setVisible(true);
    Franja3.setVisible(true);
    Franja4.setVisible(true); 
  }
  
  public void MoureRata(int x,int y) throws AWTException {
    Robot r = new Robot();
    r.mouseMove(x,y);
    //if (ActivarQuadreSegiment) {CanviMidesQuadrat(x-50,y-50,100,100);}
    if (ActivarQuadreSegiment) {CanviMidesQuadrat(x-Global.FranjaDX/2,y-Global.FranjaDY/2,Global.FranjaDX,Global.FranjaDY);}
  }
  
  public void EngegarTimer() {
    TimerEscaneig = new Timer(TimerEscaneigInterval,this);
    TimerEscaneig.start();
  }
  
  public void actionPerformed(ActionEvent e) {
    if (WindowsVistaComensoEscaneig==false) {
      Point b = Tools.GetCursorPos();
      int x = (int) b.getX();
      int y = (int) b.getY();
      int l=Lloc-1;
      if (l==0) {l=NumeroDePunts;}
      if ((x!=px[l]) || (y!=py[l])) {
        JavaKanghooru.PararEscaneig();
        return;
      }
    }  else {
      WindowsVistaComensoEscaneig=false;
    } 
    int LlocAnterior;
    if (EnScaneigFerSonarUnBeep) {
      Toolkit.getDefaultToolkit().beep();  
    }
            
    if (e.getSource() == TimerEscaneig){
      if (Lloc>NumeroDePunts) {
        Lloc=1;
        LlocAnterior=NumeroDePunts;
      } else {
        LlocAnterior=Lloc-1;  
      }
      /*
      pare.setVisible(true);
      //Hauria d'haver GetCursorPos, per no s si es pot fer amb Java
      if (PosicioX!=px[LlocAnterior]) {
        TimerEscaneig.stop();  
        TimerEscaneig = null;
        Franja1.setVisible(false);
        Franja2.setVisible(false);
        Franja3.setVisible(false);
        Franja4.setVisible(false);    
      } else {
        try {
          MoureRata(px[Lloc],py[Lloc]);
        } catch (AWTException ae) {
    	   System.out.println(ae);
        }
        Lloc=Lloc+1;
      }
       */
      /**/
      pare.setVisible(true);
      try {
        MoureRata(px[Lloc],py[Lloc]);
      } catch (AWTException ae) {
         System.out.println(ae);
      }
      Lloc=Lloc+1;
       /**/
    }
  }
  
  public void mouseReleased(MouseEvent e) { 
    //pare.setTitle(String.valueOf(e.getButton()));
    if (e.getButton()==3) {
      setVisible(false);
      pare.setVisible(true);
    } else if (e.getButton()==1) {
      if (NumeroDePunts<=NumeroMaximDePunts) {
        NumeroDePunts=NumeroDePunts+1;  
        px[NumeroDePunts]=e.getX();
        py[NumeroDePunts]=e.getY();
      }
    }
  }

  public void mouseMoved(MouseEvent e) { }
  public void mousePressed(MouseEvent e) { }      
  public void mouseDragged(MouseEvent e) { }
  public void mouseExited(MouseEvent e) { }
  public void mouseClicked(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) { }

}
