/*
 * Projecte Fressa a JAVA
 * TFormTransparentBackground.java
 * Created on 24 / abril / 2009, 21:12
 *
 * @author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 * amb el suport del Departament d'Educacio de la Generalitat de Catalunya
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 */
    
import java.awt.*;
import java.awt.event.*;

public class TFormTransparentBackground extends javax.swing.JDialog {
    
  public javax.swing.JButton jButtonDAcord;
  public javax.swing.JButton jButtonCancelar;

  public int resultat = 0;

  public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
      public void run() {
        new TFormTransparentBackground(new javax.swing.JFrame(), true).setVisible(true);
      }
    });
  }
    
  public TFormTransparentBackground(java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
  }
    
  public TFormTransparentBackground(javax.swing.JDialog parent, boolean modal) {
    super(parent, modal);
    initComponents();
  }

  private void initComponents() {
    
    TransparentBackground bg = new TransparentBackground(this);
    getContentPane().add(bg);
    pack();
    setSize(387,280);

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    //setTitle("Form Dialog");
    setResizable(true);
    
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        Global.FranjaDX=getWidth();
        Global.FranjaDY=getHeight();
        Toolkit.getDefaultToolkit().removeAWTEventListener(ListenerReturnEsc);
      }
    });
    
  }
  
  private AWTEventListener ListenerReturnEsc = new AWTEventListener() {
    public void eventDispatched(AWTEvent event) {
      KeyEvent ke = (KeyEvent)event;
      if (ke.getID() == KeyEvent.KEY_TYPED) {
        if (ke.getKeyChar() == KeyEvent.VK_ESCAPE) {
          jButtonCancelarClick();
        } else if (ke.getKeyChar() == KeyEvent.VK_ENTER) {
          if (jButtonCancelar.isFocusOwner()) {
            jButtonCancelarClick()  ;
          } else {
            jButtonDAcordClick();
          }             
        }
      }
    }
  };

  private void jButtonDAcordClick() {                                         
    Toolkit.getDefaultToolkit().removeAWTEventListener(ListenerReturnEsc);
    resultat=1;
    setVisible(false);
  }                                        

  private void jButtonCancelarClick() {                                         
    Toolkit.getDefaultToolkit().removeAWTEventListener(ListenerReturnEsc);
    resultat=0;
    setVisible(false);        
  }                                        

  public void ShowModalCentered() {
    Toolkit.getDefaultToolkit().addAWTEventListener(ListenerReturnEsc,AWTEvent.KEY_EVENT_MASK);
    setSize(Global.FranjaDX,Global.FranjaDY);
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = this.getSize();
    if (frameSize.height > screenSize.height) frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width) frameSize.width = screenSize.width;
    this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    this.setVisible(true);      
  }
  
}
